package cmd

import (
	"errors"
	"fmt"
	"os/exec"
	"strings"
)

var ErrNotFound = errors.New("which: command not found")

func Which(cmd string) (string, error) {

	command := exec.Command("which", cmd)

	outputBytes, err := command.Output()
	if err != nil {
		var exitErr *exec.ExitError
		if errors.As(err, &exitErr) {
			if exitErr.ExitCode() == 1 {
				return "", ErrNotFound
			} else {
				return "", fmt.Errorf("command error: %w", err)
			}
		}
	}

	return strings.Trim(string(outputBytes), "\n"), nil

}
